﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.ComponentModel;

namespace BindingIssue.View
{
    /// <summary>
    /// Interaction logic for Main.xaml
    /// </summary>
    public partial class Main : Page,INotifyPropertyChanged
    {
        public Main()
        {
            InitializeComponent();
            this.DataContext = this;
            
             
            XamChangeSource = true;
            ChangeSource = false;
        }

        //This gets called only once
        private bool? changeSource;
        public bool? ChangeSource
        {
            get { return changeSource; }
            set
            {
                changeSource = value;
                OnPropertyChanged("ChangeSource");
            }
        }

        //This gets called multiple times if I click on the control to type in it
        private bool? xamChangeSource;
        public bool? XamChangeSource
        {
            get { return xamChangeSource; }
            set
            {
                xamChangeSource = value;
                OnPropertyChanged("XamChangeSource");
            }
        }

        #region PropertyChanged
        public event PropertyChangedEventHandler PropertyChanged;

        protected void OnPropertyChanged(PropertyChangedEventArgs e)
        {
            var handler = this.PropertyChanged;
            if (handler != null)
            {
                handler(this, e);
            }
        }

        /// <summary>
        /// Event handler for PropertyChanged events
        /// </summary>
        /// <param name="propertyName">property name</param>
        protected void OnPropertyChanged(string propertyName)
        {
            this.OnPropertyChanged(new PropertyChangedEventArgs(propertyName));
        }
        #endregion
    }
}
